/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002,2003,2004 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef POLYXEDIT_EDITCTXT_H
#define POLYXEDIT_EDITCTXT_H

#include "polyxedit-globals.h"

typedef struct _PxmEditCtxt PxmEditCtxt;


struct _PxmEditCtxt
{
  /* The sequence editor window.
   */
  GtkWidget *sequence_editor_wnd;
  
  /* Polymer instance that holds all the sequence information.
   */
  PxmPolymer *polymer;

  /* Polymer definition context related to the polymer sequence.  This
   * is not a structure allocated here, it is only a reference.
   */
  PxmPolchemdefCtxt *polchemdefctxt;

  /* The mass calculation engine configurator.
   */
  PxmCalcOpt *calcopt;

  /* The ionization chemistry configurator.
   */
  PxmIonizerule *ionizerule;
  
  /* The conventional system of prop array.
   */
  GPtrArray *propGPA;
};






/* NEW'ING FUNCTIONS, DUPLICATING FUNCTIONS ...
 */
PxmEditCtxt *
polyxedit_editctxt_new (void);



/*  LOCATING FUNCTIONS
 */
gint
polyxedit_editctxt_get_index_by_polymer (PxmPolymer *polymer,
					   GPtrArray *GPA);

PxmEditCtxt *
polyxedit_editctxt_get_ptr_by_polymer (PxmPolymer *polymer,
					 GPtrArray *GPA);

gint
polyxedit_editctxt_get_index (PxmEditCtxt *editctxt,
				GPtrArray *GPA);





/* REFERENCE COUNTING MANAGEMENT
 */
gint
polyxedit_editctxt_remove_from_GPA (PxmEditCtxt *editctxt, 
				      GPtrArray *GPA);




/* FREE'ING FUNCTIONS
 */
gboolean
polyxedit_editctxt_free (PxmEditCtxt *editctxt);




/* GPtrArray-RELATED FUNCTIONS
 */
gint
polyxedit_editctxt_GPA_free (GPtrArray *GPA);








#endif /* ifndef POLYXEDIT_EDITCTXT_H */
